{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y-}
{$M 16384,0,655360}
{by Behdad Esfahbod}
program
  ContextFreeExpressionGenerator;
const
  MaxLength = 10;
  InF  = 'rules.in';
  OutF = 'exprsion.out';
type
  TRule    = record
    C : Char;
    S : String[MaxLength];
    W : Integer;
  end;
  TNonTerm  = record
    D, SigmaW, Start : Integer;
  end;
  TNonTerms = array ['A' .. 'Z'] of TNonTerm;
  TList     = array [1 .. 2000] of TRule;
  PSt       = ^ TSt;
  TSt       = array [1 .. 32000] of Char;
var
  N, L, MH : Integer;
  List1, List2 : TList;
  MinH, MaxH, MaxL, MinL : Integer;
  NT : TNonTerms;
  Ch1, Ch2 : Char;
  I, J : Integer;
  Leng : Integer;
  S1 : string;
  Stt : PSt;
  Error : Boolean;
  F : Text;
  F2 : file;
  TT : Longint;
  Time : Longint absolute $40:$6C;

procedure MakeString (Ch : Char; H : Integer);
var
  I, J : Integer;
  St : string;
begin
if H > MaxH then begin Error := True; Exit; end;
if H > MH then MH := H;
if Ch = 'A' then
begin
  Inc(Leng);
  Stt^[Leng] := Chr(Ord('a')+Random(26));
  Exit;
end
else
if Ch = 'D' then
begin
  Str(Random(10000) / 100 : 0 : 2, St);
  for J := 1 to Length(St) do
    Stt^[Leng + J] := St[J];
  Inc(Leng, Length(St));
  Exit;
end;
with NT[Ch] do
begin
  I := Start + Random(SigmaW);
  with List2[I] do
  begin
  for J := 1 to Length(S) do
  begin
    if not (S[J] in ['A' .. 'Z']) then
    begin
      Inc(Leng);
      Stt^[Leng] := S[J];
    end
    else
      MakeString(S[J], H + 1);
  end;
  end;
end;
end;

begin
  Assign(F, InF);
  Reset(F);
  Readln(F, N, S1);
  while S1[1] = ' ' do S1 := Copy(S1, 2, MaxLength);
  Ch2 := S1[1];
  RandSeed := N;
  for I := 1 to N do
  with List1[I] do
  begin
    Readln(F, W, S1);
    while S1[1] = ' ' do S1 := Copy(S1, 2, MaxLength);
    C := S1[1];
    S := Copy(S1, 4, MaxLength);
    Inc(NT[C].SigmaW, W);
    Inc(RandSeed, W);
  end;

  Randomize;

  Close(F);
  L := 0;
  for Ch1 := 'A' to 'Z' do
  if NT[Ch1].SigmaW > 0 then
  begin
    NT[Ch1].Start := L + 1;
    for I := 1 to N do
    if List1[I].C = Ch1 then
    with List1[I] do
      for J := 1 to W do
      begin
        Inc(L);
        List2[L] := List1[I];
      end;
  end;
  if ParamStr(1) <> '' then Val(ParamStr(1), MinL, I) else MinL := 10;
	MaxL := MinL + 30;
  if ParamStr(2) <> '' then
	begin
	  Val(ParamStr(2), MaxL, I);
    if MaxL <= MinL then MinL := MaxL - 30;
  end;
  if ParamStr(3) <> '' then Val(ParamStr(3), MinH, I) else MinH := 2;
  MaxH := MinH + 8;
  if ParamStr(4) <> '' then
	begin
	  Val(ParamStr(4), MaxH, I);
    if MaxH < MinH then MinH := MaxH - 8;
  end;
  New(Stt);
  TT := Time;
  repeat
    Error := False;
    Leng := 0;
    if Time - TT > 50 then Break;
    MakeString(Ch2, 1);
  until (Error = False) and (Leng >= MinL) and (Leng <= MaxL) and (MH >= MinH);
  Stt^[Leng + 1] := #13;
  Stt^[Leng + 2] := #10;
  Inc(Leng, 2);
  Assign(F2, OutF);
  ReWrite(F2, 1);
  BlockWrite(F2, Stt^, Leng);
  Close(F2);
end.